<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RelRentabilidadeProdContinuoService;
use Teknisa\MAN\Utilities;

class RelRentabilidadeProdContinuo  {

    protected $utilService;
    
    public function __construct(Utilities\Util $utilService, RelRentabilidadeProdContinuoService $RelRentabilidadeProdContinuoService) {
        $this->utilService   = $utilService;
        $this->reportService = $RelRentabilidadeProdContinuoService;
    }
    
    public function findReport(DTO\Request\Filter $request, DTO\Response $response) {
        ini_set('max_execution_time', 1800);
		ini_set('memory_limit', '512M');
        //$conditions = $this->utilService->getParamsAsArray($request);
        $conditions = $request->getFilterCriteria()->getConditions();
        $params = $this->buildQueryParams($conditions);
        $result = $this->reportService->fetchReport($params);
        $response->addDataSet(new DataSet("orm00007_rentabilidadeProdContinuo", $result));
        return $response;
    }
    
    private function buildQueryParams($conditions){
        $params = array();
        if(!empty($conditions)){
            foreach ($conditions as $filtro) {
               if ($filtro['operator'] == '=') {
                   $params[$filtro['columnName']] = $filtro['value']; 
               }else if($filtro['operator'] == 'MAPPED_LIKE_ALL'){
                   $params['ALLFIEDLS'] = $filtro['value'][0]['_ALL'];
               }else if(($filtro['operator'] == 'BETWEEN') or ($filtro['operator'] == 'IN')){
                   $params[$filtro['columnName']] = $filtro['value'];
               }
            }
        }
        return $params;
    }
}
