<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\ORM\ConnectionFactory;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class SMTP extends \Zeedhi\Framework\Controller\Simple {

	protected $SMTPService;
	protected $salesMessage;
	protected $util;
	protected $geralService;

	public function __construct(Services\SMTP $SMTPService, Utilities\SalesMessage $salesMessage, Utilities\Util $util, Services\Geral $geralService) {
		$this->SMTPService = $SMTPService;
		$this->salesMessage = $salesMessage;
        $this->util = $util;
        $this->geralService = $geralService;
	}

	public function getSMTP(Request\Filter $request, Response $response) {
        try {
            $SMTP = $this->SMTPService->getSMTP();
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('SMTPRepo', $SMTP));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    public function getSMTPFilial(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();
            $CDFILIAL     = $params[0]['value'];
            $SMTPFilial = $this->SMTPService->getSMTPFilial($CDFILIAL);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('SMTPFilialRepo', $SMTPFilial));

        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    public function atualizaSMTP(Request\Filter $request, Response $response) {
        try {
            $params = $request->getFilterCriteria()->getConditions();
            $params =  $this->util->replaceParams($params);

            $DSSMTPAUTVND     = $params[0]['value'];
            $DSEMAILAUVND     = $params[1]['value'];
            $NRPORTAAUTVND    = $params[2]['value'];
            $CDSENHAAUTVNDWEB = $params[3]['value'];
            $DSEMAILCLUSO     = $params[4]['value'];
            $DSSMTPCRIPT      = $params[5]['value'];
            $IDTPAUTHSMTP     = $params[6]['value'];

            if ($NRPORTAAUTVND == '') {
            	$NRPORTAAUTVND = null;
            }

            $SMTP = $this->geralService->atualizaSMTP($DSSMTPAUTVND, $DSEMAILAUVND, $NRPORTAAUTVND, $CDSENHAAUTVNDWEB, $DSEMAILCLUSO, $DSSMTPCRIPT, $IDTPAUTHSMTP);
            $response->addMessage(new Message($this->salesMessage->getMessage(35)));
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('nothing', array(array('nothing' => 'nothing'))));
        } catch (\Exception $e) {
            $response->addMessage(new Message($e->getMessage()));
        }
    }

    public function testaSMTP(Request\Filter $request, Response $response) {
        try {
            $params = $request->getFilterCriteria()->getConditions();
            $EMAIL  = $params[0]['value'];
            $EMAIL = strtolower($EMAIL);

	        $subject  = $this->salesMessage->getMessage('105');
	        $sender = $this->salesMessage->getMessage('102');
	        $content =
	        	'<center>'.
		        '<p>Teste de configuração de SMTP do Odhen Manage.</p>'.
	            '<p>Se não requisitou este teste, ignore essa mensagem.<b><br>'.
	            '</center>'
			;
            $this->SMTPService->sendEmail($EMAIL, $EMAIL, $sender, $subject, $content);

            $response->addMessage(new Message($this->salesMessage->getMessage(71)));
        } catch (\Exception $e) {
            $response->addMessage(new Message($this->salesMessage->getMessage(72)));
        }
        
        
    }

}